local Root = "L:/Client"
local AreaStr = ""
if io and io.popen and not LuaTinker then
	local cd = io.popen( "cd" ):read( '*l' )
	print( "cd: "..cd )
	local s, e = string.find( cd, "Client" )
	if e then
		Root = string.sub( cd, 1, e )
	end
end

if arg and arg[1] and arg[2] then
	Root = arg[1]
	AreaStr = arg[2]
end

Root = string.gsub( Root, '\\', '/' )
local DatabaseRoot = Root.."/Assets/StreamingAssets/Database/"..AreaStr
local LuaRoot = Root.."/Assets/StreamingAssets/LuaRoot"
package.path = package.path..';'..DatabaseRoot..'/?.lua'..';'.. LuaRoot..'/?.lua'

local DatabaseTool = require "DatabaseTool"
local LocalizeDatabase = require "LocalizeDatabase"
DatabaseTool.DatabaseRoot = DatabaseRoot

local language = nil
if arg and arg[2] and LocalizeDatabase.IsLanguageSupported( arg[2] ) then
	language = arg[2]
	print( "current language: "..language )
end

print( "DatabaseRoot:"..DatabaseRoot )

-- dataset
-- dataset rename
-- containId
-- true or false to enable cache
-- a name for inverse cache
-- save to file if true
-- use gc cache, not support two caches
local tofile = true
if tofile then

DatabaseTool.Load( "ladder_item" )
	DatabaseTool.GenCSharpDefine( Database.ladder_item, "Ladder_item", true, true, nil, tofile )

	DatabaseTool.Load( "ladder_1v1_reward" )
	DatabaseTool.GenCSharpDefine( Database.ladder_1v1_reward, "Ladder_1v1_reward", true, true, nil, tofile )

    DatabaseTool.Load( "partner_animation" )
	DatabaseTool.GenCSharpDefine( Database.partner_animation, "PartnerAnimation", true, true, nil, tofile )

	DatabaseTool.Load( "sourceshop" )
	DatabaseTool.GenCSharpDefine( Database.sourceshop, "sourceshop", true, true, nil, tofile )

	DatabaseTool.Load( "cost" )
	DatabaseTool.GenCSharpDefine( Database.cost, "Cost", true, true, nil, tofile )

	DatabaseTool.Load( "petEquipment" )
	DatabaseTool.GenCSharpDefine( Database.petEquipment, "PetEquipment", true, true, nil, tofile )

	DatabaseTool.Load( "petEquipmentLevel" )
	DatabaseTool.GenCSharpDefine( Database.petEquipmentLevel, "PetEquipmentLevel", true, true, nil, tofile )

	DatabaseTool.Load( "titlesystem" )
	DatabaseTool.GenCSharpDefine( Database.titlesystem, "TitleSystem", true, true, nil, tofile )

	DatabaseTool.Load( "RechargeFirstAD" )
	DatabaseTool.GenCSharpDefine( Database.RechargeFirstAD, "RechargeFirstAD", true, true, nil, tofile )

	DatabaseTool.Load( "MonthCard" )
	DatabaseTool.GenCSharpDefine( Database.MonthCard, "MonthCard", true, true, nil, tofile )

	 DatabaseTool.Load( "RechargeFirst" )
	DatabaseTool.GenCSharpDefine( Database.RechargeFirst, "RechargeFirst", true, true, nil, tofile )

	 DatabaseTool.Load( "RechargeActivitie" )
	DatabaseTool.GenCSharpDefine( Database.RechargeActivitie, "RechargeActivitie", true, true, nil, tofile )

	 DatabaseTool.Load( "RechargeAccumulation" )
	DatabaseTool.GenCSharpDefine( Database.RechargeAccumulation, "RechargeAccumulation", true, true, nil, tofile )

    DatabaseTool.Load( "buddy_gift" )
	DatabaseTool.GenCSharpDefine( Database.buddy_gift, "BuddyGift", true, true, nil, tofile )

    DatabaseTool.Load( "buddy_dailytask" )
	DatabaseTool.GenCSharpDefine( Database.buddy_dailytask, "BuddyDailyTask", true, true, nil, tofile )

	DatabaseTool.Load( "offstringlogin" )
	DatabaseTool.GenCSharpDefine( Database.offstringlogin, "Offstringlogin", true, true, nil, tofile )

	DatabaseTool.Load( "skillCDGroup" )
	DatabaseTool.GenCSharpDefine( Database.skillCDGroup, "SkillCDGroup", true, true, nil, tofile )

	DatabaseTool.Load( "rndname" )
	DatabaseTool.GenCSharpDefine( Database.rndname, "RndName", false, false, nil, tofile )

	DatabaseTool.Load( "itemCDandCount" )
	DatabaseTool.GenCSharpDefine( Database.itemCDandCount, "ItemCDandCount", true, true, nil, tofile )

	DatabaseTool.Load( "show2" )
	DatabaseTool.GenCSharpDefine( Database.show2, "ShowTwo", true, true, nil, tofile )

	DatabaseTool.Load( "per_book" )
	DatabaseTool.GenCSharpDefine( Database.per_book, "PetBook", true, true, nil, tofile )

	DatabaseTool.Load( "PanelHelp" )
	DatabaseTool.GenCSharpDefine( Database.PanelHelp, "PanelHelp", true, true, nil, tofile )

	DatabaseTool.Load( "openbag" )
	DatabaseTool.GenCSharpDefine( Database.openbag, "OpenBag", true, true, nil, tofile )

	DatabaseTool.Load( "Gorgeous" )
	DatabaseTool.GenCSharpDefine( Database.Gorgeous, "Gorgeous", true, true, nil, tofile )

	DatabaseTool.Load( "gembox_info" )
	DatabaseTool.GenCSharpDefine( Database.gembox_info, "GemboxInfo", true, true, nil, tofile )

	DatabaseTool.Load( "help" )
	DatabaseTool.GenCSharpDefine( Database.help, "HelpText", true, true, nil, tofile )

	DatabaseTool.Load( "rank" )
	DatabaseTool.GenCSharpDefine( Database.rank, "Rank", true, true, nil, tofile )

	DatabaseTool.Load( "guide" )
	DatabaseTool.TrimDatasetFile(
		Database.guide, {
		"beizhu", "help_text", "parameter_2", "ShowHp"
		},
		tofile
	)

	DatabaseTool.Reload( "guide" )
	DatabaseTool.GenCSharpDefine( Database.guide, "Guide", true, true, nil, tofile )

	DatabaseTool.Load( "IndexGrowth" )
	DatabaseTool.GenCSharpDefine( Database.IndexGrowth, "IndexGrowth", true, true, nil, tofile )

	DatabaseTool.Load( "comboSkill" )
	DatabaseTool.GenCSharpDefine( Database.comboSkill, "ComboSkill", true, true, nil, tofile )

	DatabaseTool.Load( "show1" )
	DatabaseTool.GenCSharpDefine( Database.show1, "ShowOne", true, true, nil, tofile )

	DatabaseTool.Load( "copymapScheduleSettle" )
	DatabaseTool.GenCSharpDefine( Database.copymapScheduleSettle, "CopymapScheduleSettle", true, true, nil, tofile )

	DatabaseTool.Load( "achievement" )
	DatabaseTool.GenCSharpDefine( Database.achievement, "Achievement", true, true, nil, tofile )

	DatabaseTool.Load( "achievecollection" )
	DatabaseTool.GenCSharpDefine( Database.achievecollection, "Achievecollection", true, true, nil, tofile )

	DatabaseTool.Load( "mapConvey" )
	DatabaseTool.GenCSharpDefine( Database.mapConvey, "MapConveySetting", true, true, nil, tofile )

	DatabaseTool.Load( "bloom" )
	DatabaseTool.GenCSharpDefine( Database.bloom, "BloomSetting", true, true, nil, tofile )

	DatabaseTool.Load( "Lottery" )
	DatabaseTool.GenCSharpDefine( Database.Lottery, "Lottery", true, true, nil, tofile )

	DatabaseTool.Load( "object" )
	DatabaseTool.GenCSharpDefine( Database.object, "Object", true, true, nil, tofile )

	DatabaseTool.Load( "offstringingame" )
	DatabaseTool.GenCSharpDefine( Database.offstringingame, "Offstringingame", false, true, nil, tofile, false )

	DatabaseTool.Load( "player_desc" )
	DatabaseTool.GenCSharpDefine( Database.player_desc, "PlayerDesc", true, true, nil, tofile, true )

	DatabaseTool.Load( "bloom" )
	DatabaseTool.GenCSharpDefine( Database.bloom, "BloomSetting", true, true, nil, true )

	DatabaseTool.Load( "chaos" )
	DatabaseTool.GenCSharpDefine( Database.chaos, "Chaos", true, true, nil, true )

	DatabaseTool.Load( "monster" )
	DatabaseTool.TrimDatasetFile(
		Database.monster, {
		"tough", "WatchRadius", "SlowResist", "ShowHp",
		"ShadowResist", "ShadowDamage", "SealResist", "PhysicalResist",
		"PhysicalDamage", "PatrolSpeed", "PatrolRadius", "Parry", "OwnerShip",
		"MonsterRace", "MonsterCd", "MobdesA", "MobdesB", "HolyResist", "HolyDamage",
		"FollowRadius", "Faction", "Exp", "ElementResist", "ElementDamage", "DropShip",
		"DropList", "DominateResist", "Dodge", "Critical", "ChaosResist", "ChaosDamage",
		"ChangeInterval", "Block", "MonsterAI", "EquipDropList", "SkillInterval"
		},
		tofile
	)
	DatabaseTool.Reload( "monster" )
	DatabaseTool.GenCSharpDefine( Database.monster, "Monster", true, true, nil, tofile )

	DatabaseTool.Load( "npc" )
	DatabaseTool.GenCSharpDefine( Database.npc, "Npc", true, true, nil, tofile )

	DatabaseTool.Load( "mapsetting" )
	DatabaseTool.GenCSharpDefine( Database.mapsetting, "Mapsetting", true, true, nil, tofile )

	DatabaseTool.Load( "changemaphelp" )
	DatabaseTool.GenCSharpDefine( Database.changemaphelp, "Changemaphelp", true, true, nil, tofile )

	DatabaseTool.Load( "changemaphelp" )
	DatabaseTool.GenCSharpDefine( Database.changemaphelp, "Changemaphelp", true, true, nil, tofile )

	DatabaseTool.Load( "item" )
	DatabaseTool.TrimDatasetFile(
		Database.item, {
		"dailyCountGroup", "detailedType", "isQuestItem", "needBrodcast", "needSaveLog", "product"
		},
		tofile
	)

	DatabaseTool.Reload( "item" )
	DatabaseTool.GenCSharpDefine( Database.item, "Item", true, true, nil, tofile )

	DatabaseTool.Load( "mount" )
	DatabaseTool.GenCSharpDefine( Database.mount, "Mount", true, true, nil, tofile, true )

	DatabaseTool.Load( "MountSkin" )
	DatabaseTool.GenCSharpDefine( Database.MountSkin, "MountSkin", true, true, nil, tofile, true )

	DatabaseTool.Load( "skill" )
	DatabaseTool.GenCSharpDefine( Database.skill, "Skill", true, true, nil, tofile )

	DatabaseTool.Load( "camera_shake" )
	DatabaseTool.GenCSharpDefine( Database.camera_shake, "CameraShake", true, true, nil, tofile )

	DatabaseTool.Load( "skill_effect" )
	DatabaseTool.GenCSharpDefine( Database.skill_effect, "SkillEffect", true, true, nil, tofile )

	DatabaseTool.Load( "TierBonus" )
	DatabaseTool.GenCSharpDefine( Database.TierBonus, "TierBonus", false, true, nil, tofile, true )

	DatabaseTool.Load( "player_desc" )
	DatabaseTool.GenCSharpDefine( Database.player_desc, "PlayerDesc", true, true, nil, tofile, true )

	DatabaseTool.Load( "mainMenu" )
	DatabaseTool.GenCSharpDefine( Database.mainMenu, "MainMenu", true, true, nil, tofile, true )

	DatabaseTool.Load( "gemproperty" )
	DatabaseTool.GenCSharpDefine( Database.gemproperty, "Gemproperty", true, true, nil, tofile, true )

	DatabaseTool.Load( "pet" )
	DatabaseTool.GenCSharpDefine( Database.pet, "Pet", true, true, nil, tofile, true )

	DatabaseTool.Load( "bussyItemTree" )
	DatabaseTool.GenCSharpDefine( Database.bussyItemTree, "BussyItemTree", true, true, nil, tofile, true )

	DatabaseTool.Load( "buff" )
	DatabaseTool.TrimDatasetFile(
		Database.buff, {
		"BuffDelay", "BuffDescribe", "BuffRemove", "BuffStart", "BuffType", "Buffstore", "CheckResult",
		"CriAble", "DamFactor", "DamageType", "HealProperty", "MultiBuffMultiCaster", "MultiBuffOneCaster",
		"OneBuffMultiCaster", "OneBuffOneCaster", "OutSenceDel", "PlusDamType", "ResultSkill", "SaveCheck",
		},
		tofile
	)

	DatabaseTool.Reload( "buff" )
	DatabaseTool.GenCSharpDefine( Database.buff, "Buff", true, true, nil, tofile )

	DatabaseTool.Load( "battlePropInfo" )
	DatabaseTool.GenCSharpDefine( Database.battlePropInfo, "BattlePropInfo", true, true, nil, tofile )

	DatabaseTool.Load( "drop" )
	DatabaseTool.GenCSharpDefine( Database.drop, "Drop", true, true, nil, tofile, true )

	DatabaseTool.Load( "drop_package" )
	DatabaseTool.GenCSharpDefine( Database.drop_package, "DropPackage", true, true, nil, tofile, true )

	DatabaseTool.Load( "eq_charge" )
	DatabaseTool.GenCSharpDefine( Database.eq_charge, "EquipBasePrice", true, true, nil, tofile, true )

	DatabaseTool.Load( "equipdrop" )
	DatabaseTool.GenCSharpDefine( Database.equipdrop, "EquipDrop", true, true, nil, tofile, true )

	DatabaseTool.Load( "task_group" )
	DatabaseTool.GenCSharpDefine( Database.task_group, "TaskGroup", true, true, nil, tofile, true )

	DatabaseTool.Load( "task_new" )
	DatabaseTool.TrimDatasetFile(
		Database.task_new, {
		"open"
		},
		tofile
	)

	DatabaseTool.Reload( "task_new" )
	DatabaseTool.GenCSharpDefine( Database.task_new, "TaskNew", true, true, nil, tofile, true )

	DatabaseTool.Load( "dungeonschallenge" )
	DatabaseTool.GenCSharpDefine( Database.dungeonschallenge, "CopyReward", true, true, nil, tofile, true )

	DatabaseTool.Load( "UserFeedbackType" )
	DatabaseTool.GenCSharpDefine( Database.UserFeedbackType, "UserFeedbackType", true, true, nil, tofile, true )

	DatabaseTool.Reload( "equipment" )
	DatabaseTool.GenCSharpDefine( Database.equipment, "Equipment", true, true, nil, tofile )

	DatabaseTool.Load( "copymapScheduleInit" )
	DatabaseTool.GenCSharpDefine( Database.copymapScheduleInit, "CopymapScheduleInit", true, true, nil, tofile, false )

	DatabaseTool.Load( "ChatCommon" )
	DatabaseTool.GenCSharpDefine( Database.ChatCommon, "ChatCommon", true, false, nil, tofile, false )

	DatabaseTool.Load( "talktoplayer" )
	DatabaseTool.GenCSharpDefine( Database.talktoplayer, "TalkToPlayer", true, true, nil, tofile, true )

	DatabaseTool.Load( "EventSoundCfg" )
	DatabaseTool.GenCSharpDefine( Database.EventSoundCfg, "EventSoundCfg", true, true, nil, tofile )

	DatabaseTool.Load( "UiSoundCfg" )
	DatabaseTool.GenCSharpDefine( Database.UiSoundCfg, "UiSoundCfg", true, true, nil, tofile )

	DatabaseTool.Load( "DailyInterface" )
	DatabaseTool.GenCSharpDefine( Database.DailyInterface, "DailyInterface", true, true, nil, tofile, true )

	DatabaseTool.Load( "knighted_level" )
	DatabaseTool.GenCSharpDefine( Database.knighted_level, "KnightedLevel", true, true, nil, tofile, true )

	DatabaseTool.Load( "Honor" )
	DatabaseTool.GenCSharpDefine( Database.Honor, "Honor", true, true, nil, tofile, true )

	DatabaseTool.Load( "Welfare" )
	DatabaseTool.GenCSharpDefine( Database.Welfare, "Welfare", true, true, nil, tofile, true )

	DatabaseTool.Load( "di_mixcost" )
	DatabaseTool.GenCSharpDefine( Database.di_mixcost, "DiMixcost", true, true, nil, tofile, true )

	DatabaseTool.Load( "fashion" )
	DatabaseTool.GenCSharpDefine( Database.fashion, "Fashion", true, false, nil, tofile, false )

	DatabaseTool.Load( "EquipAffixes" )
	DatabaseTool.GenCSharpDefine( Database.EquipAffixes, "EquipAffixes", true, true, nil, tofile, true )

	DatabaseTool.Load( "globalsetup" )
	DatabaseTool.GenCSharpDefine( Database.globalsetup, "GlobalSetup", true, true, nil, tofile )

	DatabaseTool.Load( "transform" )
	DatabaseTool.GenCSharpDefine( Database.transform, "TransformCard", true, true, nil, tofile )

	DatabaseTool.Load( "transformspell" )
	DatabaseTool.GenCSharpDefine( Database.transformspell, "TransformNewSkill", true, true, nil, tofile )

	DatabaseTool.Load( "petLevelProperty" )
	DatabaseTool.GenCSharpDefine( Database.petLevelProperty, "PetLevelProperty", true, true, nil, tofile )

	DatabaseTool.Load( "petSkill" )
	DatabaseTool.GenCSharpDefine( Database.petSkill, "PetSkill", true, true, nil, tofile )

	DatabaseTool.Load( "activitylist" )
	DatabaseTool.GenCSharpDefine( Database.activitylist, "Activitylist", true, true, nil, tofile, true )

	DatabaseTool.Reload( "UniqTierProperty" )
	DatabaseTool.GenCSharpDefine( Database.UniqTierProperty, "UniqTierProperty", true, true, nil, tofile )

	DatabaseTool.Reload( "sweeping_drop" )
	DatabaseTool.GenCSharpDefine( Database.sweeping_drop, "SweepingDrop", true, true, nil, tofile )

	DatabaseTool.Reload( "talentExp" )
	DatabaseTool.GenCSharpDefine( Database.talentExp, "TalentExp", true, true, nil, tofile )


	DatabaseTool.Reload( "talentProp" )
	DatabaseTool.GenCSharpDefine( Database.talentProp, "TalentProp", true, true, nil, tofile )

	DatabaseTool.Reload( "warriortrial" )
	DatabaseTool.GenCSharpDefine( Database.warriortrial, "Warriortrial", true, true, nil, tofile )

	DatabaseTool.Reload( "fashionCollection" )
	DatabaseTool.GenCSharpDefine( Database.fashionCollection, "FashionCollection", true, true, nil, tofile )

	-- Ŀǰñ
	DatabaseTool.Reload( "equipIntenLevel" )
	DatabaseTool.GenCSharpDefine( Database.equipIntenLevel, "EquipIntensify", true, true, nil, tofile )

	DatabaseTool.Reload( "equipNewInten" )
	DatabaseTool.GenCSharpDefine( Database.equipNewInten, "EquipNewInten", true, true, nil, tofile )

	DatabaseTool.Reload( "mysterious_shop" )
	DatabaseTool.GenCSharpDefine( Database.mysterious_shop, "Mysterious_shop", true, true, nil, tofile )

	DatabaseTool.Reload( "Dailyrecharge" )
	DatabaseTool.GenCSharpDefine( Database.Dailyrecharge, "Dailyrecharge", true, true, nil, tofile )

	DatabaseTool.Reload( "indexFunction" )
	DatabaseTool.GenCSharpDefine( Database.indexFunction, "IndexFunction", true, true, nil, tofile )

	DatabaseTool.Reload( "shenqi" )
	DatabaseTool.GenCSharpDefine( Database.shenqi, "ShenQi", true, true, nil, tofile )

	DatabaseTool.Reload( "skill_up" )
	DatabaseTool.GenCSharpDefine( Database.skill_up, "SkillUp", true, true, nil, tofile )

	DatabaseTool.Reload( "Accessresources" )
	DatabaseTool.GenCSharpDefine( Database.Accessresources, "Accessresources", true, true, nil, tofile )

	DatabaseTool.Reload( "ImprovePower" )
	DatabaseTool.GenCSharpDefine( Database.ImprovePower, "ImprovePower", true, true, nil, tofile )

	DatabaseTool.Reload( "EquipmentDisplay" )
	DatabaseTool.GenCSharpDefine( Database.EquipmentDisplay, "EquipmentDisplay", true, true, nil, tofile )

	DatabaseTool.Reload( "petAvatareffect" )
	DatabaseTool.GenCSharpDefine( Database.petAvatareffect, "petAvatareffect", true, true, nil, tofile )

	DatabaseTool.Reload( "petWar" )
	DatabaseTool.GenCSharpDefine( Database.petWar, "PetWar", true, true, nil, tofile )

	DatabaseTool.Reload( "question" )
	DatabaseTool.GenCSharpDefine( Database.question, "Question", true, true, nil, tofile )

	DatabaseTool.Reload( "battlepower" )
	DatabaseTool.GenCSharpDefine( Database.battlepower, "Battlepower", true, true, nil, tofile )

	DatabaseTool.Reload( "knightedPackage" )
	DatabaseTool.GenCSharpDefine( Database.knightedPackage, "KnightedPackage", true, true, nil, tofile )

	DatabaseTool.Reload( "wildboss" )
	DatabaseTool.GenCSharpDefine( Database.wildboss, "Wildboss", true, true, nil, tofile )

	DatabaseTool.Reload( "escort_event" )
	DatabaseTool.GenCSharpDefine( Database.escort_event, "EscortEvent", true, true, nil, tofile )

	DatabaseTool.Reload( "signinaward" )
	DatabaseTool.GenCSharpDefine( Database.signinaward, "SigninAward", true, true, nil, tofile )

	DatabaseTool.Reload( "Dailytask" )
	DatabaseTool.GenCSharpDefine( Database.Dailytask, "Dailytask", true, true, nil, tofile )

	DatabaseTool.Reload( "equipstar" )
	DatabaseTool.GenCSharpDefine( Database.equipstar, "Equipstar", true, true, nil, tofile )

	DatabaseTool.Reload( "pet_stronger" )
	DatabaseTool.GenCSharpDefine( Database.pet_stronger, "PetStronger", true, true, nil, tofile )

	DatabaseTool.Reload( "divine" )
	DatabaseTool.GenCSharpDefine( Database.divine, "divine", true, true, nil, tofile )

	DatabaseTool.Reload( "strings" )
	DatabaseTool.GenCSharpDefine( Database.strings, "strings", true, true, nil, tofile )

	DatabaseTool.Reload( "worldlevel_exp" )
	DatabaseTool.GenCSharpDefine( Database.worldlevel_exp, "WorldLevelExp", true, true, nil, tofile )

	DatabaseTool.Reload( "pet_pvp" )
	DatabaseTool.GenCSharpDefine( Database.pet_pvp, "PetPVP", true, true, nil, tofile )

	DatabaseTool.Reload( "guildskill" )
	DatabaseTool.GenCSharpDefine( Database.guildskill, "GuildSkill", true, true, nil, tofile )

	DatabaseTool.Reload( "guildbuff" )
	DatabaseTool.GenCSharpDefine( Database.guildbuff, "GuildBuff", true, true, nil, tofile )

	DatabaseTool.Reload( "guildsupplies" )
	DatabaseTool.GenCSharpDefine( Database.guildsupplies, "guildSupplies", true, true, nil, tofile )

	DatabaseTool.Reload( "Notification" )
	DatabaseTool.GenCSharpDefine( Database.Notification, "Notification", true, true, nil, tofile )

	DatabaseTool.Reload( "DailyActive" )
	DatabaseTool.GenCSharpDefine( Database.DailyActive, "DailyActive", true, true, nil, tofile )

	DatabaseTool.Reload( "wing" )
	DatabaseTool.GenCSharpDefine( Database.wing, "Wing", true, true, nil, tofile )

	DatabaseTool.Reload( "drop" )
	DatabaseTool.GenCSharpDefine( Database.drop, "Drop", true, true, nil, tofile )

	DatabaseTool.Reload( "serverstrings" )
	DatabaseTool.GenCSharpDefine( Database.serverstrings, "ServerStrings", true, true, nil, tofile )

	DatabaseTool.Reload( "ItemTinker" )
	DatabaseTool.GenCSharpDefine( Database.ItemTinker, "ItemTinker", true, true, nil, tofile )

	DatabaseTool.Reload( "guildhome_task" )
	DatabaseTool.GenCSharpDefine( Database.guildhome_task, "GuildhomeTask", true, true, nil, tofile )

	DatabaseTool.Reload( "koreangift" )
	DatabaseTool.GenCSharpDefine( Database.koreangift, "Koreangift", true, true, nil, tofile )

	DatabaseTool.Reload( "VIP_color" )
	DatabaseTool.GenCSharpDefine( Database.VIP_color, "VIP_color", true, true, nil, tofile )

	DatabaseTool.Reload( "player_skills_upgrading" )
	DatabaseTool.GenCSharpDefine( Database.player_skills_upgrading, "PlayerSkillsUpgrading", true, true, nil, tofile )

	DatabaseTool.Reload( "monthly_signinaward" )
	DatabaseTool.GenCSharpDefine( Database.monthly_signinaward, "MonthlySigninaward", true, true, nil, tofile )

	DatabaseTool.Reload( "VIP_expression" )
	DatabaseTool.GenCSharpDefine( Database.VIP_expression, "VipExpression", true, true, nil, tofile )

	DatabaseTool.Reload( "online_reward" )
	DatabaseTool.GenCSharpDefine( Database.online_reward, "OnlineReward", true, true, nil, tofile )

	DatabaseTool.Reload( "level_reward" )
	DatabaseTool.GenCSharpDefine( Database.level_reward, "LevelReward", true, true, nil, tofile )

	DatabaseTool.Reload( "find_res" )
	DatabaseTool.GenCSharpDefine( Database.find_res, "FindRes", true, true, nil, tofile )

	DatabaseTool.Reload( "severday_task" )
	DatabaseTool.GenCSharpDefine( Database.severday_task, "Severday_task", true, true, nil, tofile )

	DatabaseTool.Reload( "angel_investment" )
	DatabaseTool.GenCSharpDefine( Database.angel_investment, "Angel_investment", true, true, nil, tofile )

	DatabaseTool.Reload( "newplayer_Story" )
	DatabaseTool.GenCSharpDefine( Database.newplayer_Story, "Newplayer_Story", true, true, nil, tofile )

	DatabaseTool.Reload( "petfairy_level" )
	DatabaseTool.GenCSharpDefine( Database.petfairy_level, "PetFairyLevel", true, true, nil, tofile )

	DatabaseTool.Reload( "petfairy_point" )
	DatabaseTool.GenCSharpDefine( Database.petfairy_point, "PetFairyPoint", true, true, nil, tofile )

	DatabaseTool.Reload( "petreborn" )
	DatabaseTool.GenCSharpDefine( Database.petreborn, "PetReborn", true, true, nil, tofile )

	DatabaseTool.Reload( "rune" )
	DatabaseTool.GenCSharpDefine( Database.rune, "Rune", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_basePro" )
	DatabaseTool.GenCSharpDefine( Database.rune_basePro, "RuneBasePro", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_compound" )
	DatabaseTool.GenCSharpDefine( Database.rune_compound, "RuneCompound", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_level" )
	DatabaseTool.GenCSharpDefine( Database.rune_level, "RuneLevel", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_randomPro" )
	DatabaseTool.GenCSharpDefine( Database.rune_randomPro, "RuneRandomPro", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_suite" )
	DatabaseTool.GenCSharpDefine( Database.rune_suite, "RuneSuite", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_smeltcost" )
	DatabaseTool.GenCSharpDefine( Database.rune_smeltcost, "RuneSmeltcost", true, true, nil, tofile )

	DatabaseTool.Reload( "rune_battlepower" )
	DatabaseTool.GenCSharpDefine( Database.rune_battlepower, "RuneBattlePower", true, true, nil, tofile )

	DatabaseTool.Reload( "activity" )
	DatabaseTool.GenCSharpDefine( Database.activity, "Activity", true, true, nil, tofile )

	DatabaseTool.Reload( "Lottery" )
	DatabaseTool.GenCSharpDefine( Database.Lottery, "Lottery", true, true, nil, tofile )

	DatabaseTool.Reload( "LotteryForTower" )
	DatabaseTool.GenCSharpDefine( Database.LotteryForTower, "LotteryForTower", true, true, nil, tofile )

	DatabaseTool.Reload( "wedding_fireworkshow" )
	DatabaseTool.GenCSharpDefine( Database.wedding_fireworkshow, "WeddingFireworkshow", true, true, nil, tofile )

	DatabaseTool.Reload( "wedding_ring" )
	DatabaseTool.GenCSharpDefine( Database.wedding_ring, "WeddingRing", true, true, nil, tofile )

	DatabaseTool.Reload( "wedding_time" )
	DatabaseTool.GenCSharpDefine( Database.wedding_time, "WeddingTime", true, true, nil, tofile )

	DatabaseTool.Reload( "wedding_type" )
	DatabaseTool.GenCSharpDefine( Database.wedding_type, "WeddingType", true, true, nil, tofile )

	DatabaseTool.Reload( "wedding_type_candy" )
	DatabaseTool.GenCSharpDefine( Database.wedding_type_candy, "WeddingTypeCandy", true, true, nil, tofile )

	DatabaseTool.Reload( "petTreasure" )
	DatabaseTool.GenCSharpDefine( Database.petTreasure, "PetTreasure", true, true, nil, tofile )

	DatabaseTool.Reload( "guild_technology_tree" )
	DatabaseTool.GenCSharpDefine( Database.guild_technology_tree, "GuildTechTree", true, true, nil, tofile )

	DatabaseTool.Reload( "guild_winebottle" )
	DatabaseTool.GenCSharpDefine( Database.guild_winebottle, "GuildWineBottle", true, true, nil, tofile )

	DatabaseTool.Reload( "fumo_bidding" )
	DatabaseTool.GenCSharpDefine( Database.fumo_bidding, "Fumo_bidding", true, true, nil, tofile )

	DatabaseTool.Reload( "Interservice_modle" )
	DatabaseTool.GenCSharpDefine( Database.Interservice_modle, "InterserviceModle", true, true, nil, tofile )

	DatabaseTool.Reload( "Interservice_maze" )
	DatabaseTool.GenCSharpDefine( Database.Interservice_maze, "InterserviceMaze", true, true, nil, tofile )

	print( ">>>>>\n" )
	local exported = {}
	for k, v in pairs( Database ) do
		local t = type( v )
		if t == "table" then
			for id, vv in pairs( v ) do
				if id == 0 then
					print( "table key must not be 0!! name = "..k )
					--os.execute( "pause" )
				end
			end
		end
		exported[#exported + 1] = k
	end
	table.sort( exported,
		function( v1, v2 )
			return string.upper( v1 ) < string.upper( v2 )
		end
	)
	local d = '-'
	for _, k in ipairs( exported ) do
		local lead = string.upper( string.sub( k, 0, 1 ) )
		if d ~= lead then
			d = lead
			print( lead.."\t" )
		end
		print( "\t"..k )
	end
	print( ">>>>>\n" )
	LocalizeDatabase.ExportDatabaseLocalText( tofile, true )
end

--EOF

