------------------------------------------------------------------
-- TestLua001.lua
-- Author     : 
-- Version    : 1.0.0.0
-- Date       : 2015-10-19
-- Description: 
------------------------------------------------------------------

--[[
	Ͳ:CPU
		߶CPUƽƵ 1.71G	-- 100
		жCPUƽƵ	1.23G	-- 70
		ͶCPUƽƵ 1.11G	-- 50
		ƽ1.35G
	Ͳ:Memory
		߶ڴС 2.13G	-- 100
		жڴС 1G	-- 80
		ͶڴС 0.66G	-- 50
		ƽ1.26G
]]

local topCpuFrequence_kHz = 1803264;     	-- Ͳƽ 1.76G
local normalCpuFrequence_kHz = 1590240;     -- Ͳƽ 1.26G
local lowerCpuFrequence_kHz = 1162240;     	-- Ͳƽ 1.13G

local topTotalMemory_MB = 2186;          	-- Ͳƽ 2.13G
local normalTotalMemory_MB = 1524;          -- Ͳƽ 1.00G
local lowerTotalMemory_MB = 1024;          	-- Ͳƽ 0.66G

local topAvavibleMemory_MB = 700;			-- ʣڴ 300MB 

local topGraphicsPixelFillrate = 3000;    	-- 5G/s = top 
local topGraphicsShaderLevel = 30;        	-- shader lavel SM3.0 [10, 20, 30, 40, 41, 50, 60] levels

local function GetLerpData(minData, maxData, caculateData)
	if (caculateData > maxData) then
		return 1;
	end
	if (caculateData < minData) then
		return 0;
	end
	return (caculateData - minData) / (maxData - minData)
end
-- ֻӲ70 -- Լʽ, ȡӲϢʱ
local function CaculateMobilePerformance(cpuFrequence_kHz, totalMemory_MB, avavibleMemory_MB)
	local minusPoint = 0;	
	if (cpuFrequence_kHz > 100) then 
		if (cpuFrequence_kHz >= normalCpuFrequence_kHz) then 
			minusPoint = minusPoint + (1 - GetLerpData(normalCpuFrequence_kHz, topCpuFrequence_kHz, cpuFrequence_kHz)) * 21 * 0.3;
		elseif (cpuFrequence_kHz >= lowerCpuFrequence_kHz) then
			minusPoint = minusPoint + 21 * 0.3 + (1 - GetLerpData(lowerCpuFrequence_kHz, normalCpuFrequence_kHz, cpuFrequence_kHz)) * 21 * 0.2;
		else
			minusPoint = minusPoint +  (2 - GetLerpData(0, lowerCpuFrequence_kHz, cpuFrequence_kHz)) * 21 * 0.5;
		end
	end

	if (totalMemory_MB > 0) then
		if (totalMemory_MB >= normalTotalMemory_MB) then
			minusPoint = minusPoint + (1 - GetLerpData(normalTotalMemory_MB, topTotalMemory_MB, totalMemory_MB)) * 14 * 0.2;
		elseif (totalMemory_MB >= lowerTotalMemory_MB) then
			minusPoint = minusPoint + 14 * 0.2 + (1 - GetLerpData(lowerTotalMemory_MB, normalTotalMemory_MB, totalMemory_MB)) * 14 * 0.3;
		else
			minusPoint = minusPoint + (2 - GetLerpData(0, lowerTotalMemory_MB, totalMemory_MB)) * 14 * 0.5;
		end
	end

	if (avavibleMemory_MB > 0) then
		if avavibleMemory_MB > topAvavibleMemory_MB then avavibleMemory_MB = topAvavibleMemory_MB;end
		minusPoint = minusPoint + (((topAvavibleMemory_MB - avavibleMemory_MB) / topAvavibleMemory_MB) * 35);
	end
	return minusPoint;
end
-- ֻGPU30 -- Լʽ, ȡӲϢʱ
local function CaculateMobileGPUPerformance(graphicsPixelFillrate, graphicsShaderLevel)
	local minusPoint = 0;
	if (graphicsPixelFillrate > 0) then
		if graphicsPixelFillrate > topGraphicsPixelFillrate then graphicsPixelFillrate = topGraphicsPixelFillrate; end
		minusPoint = minusPoint + (((topGraphicsPixelFillrate - graphicsPixelFillrate) / topGraphicsPixelFillrate) * 20);
	end
	if (graphicsShaderLevel > 0) then
		if graphicsShaderLevel > topGraphicsShaderLevel then graphicsShaderLevel = topGraphicsShaderLevel; end
		minusPoint = minusPoint + (((topGraphicsShaderLevel - graphicsShaderLevel) / topGraphicsShaderLevel) * 10);
	end
	return minusPoint;
end


return{
	MobilePerformancePoint = CaculateMobilePerformance,
	MobileGPUPerformancePoint = CaculateMobileGPUPerformance
}
