local VFXRoot = "L:\\Client\\Assets\\Resources\\VFX"
local SubVFXRoot = VFXRoot.."\\".."qs"

DatabaseTool = require "DatabaseTool"

local function endswith( str, substr )
	if str == nil or substr == nil then
		return nil, "the string or the sub-string parameter is nil"
	end
	str_tmp = string.reverse( str )
	substr_tmp = string.reverse( substr )
	if string.find( str_tmp, substr_tmp ) ~= 1 then
		return false
	else
		return true
	end
end

print( "\n\n\nprint all VFX source...\n" )

local vfxTable = {}
DatabaseTool.Load( "buff" )
for k, v in pairs( Database.buff ) do
	if v.BuffSfx and v.BuffSfx ~= "0" then
		vfxTable[v.BuffSfx] = v.BuffSfx
	end
end

DatabaseTool.Load( "skill" )
for k, v in pairs( Database.skill ) do
	if v.ChargeSfx and v.ChargeSfx ~= "0" then
		vfxTable[v.ChargeSfx] = v.ChargeSfx
	end
	if v.SkillAttackSfx and v.SkillAttackSfx ~= "0" then
		vfxTable[v.SkillAttackSfx] = v.SkillAttackSfx
	end
	if v.SkillPrepareSfx and v.SkillPrepareSfx ~= "0" then
		vfxTable[v.SkillPrepareSfx] = v.SkillPrepareSfx
	end
	if v.SkillMissileSfx and v.SkillMissileSfx ~= "0" then
		vfxTable[v.SkillMissileSfx] = v.SkillMissileSfx
	end
	if v.SkillBeAtkSfx and v.SkillBeAtkSfx ~= "0" then
		vfxTable[v.SkillBeAtkSfx] = v.SkillBeAtkSfx
	end
	if v.SkillAbsorbSfx and v.SkillAbsorbSfx ~= "0" then
		vfxTable[v.SkillAbsorbSfx] = v.SkillAbsorbSfx
	end
end

DatabaseTool.Load( "monster" )
for k, v in pairs( Database.monster ) do
	if v.MonsterType == 2 then
		local animId = "carrier/".."s_"..tostring( v.Animation or "0" )
		if v.Animation ~= "0" then
			vfxTable[animId] = animId
		end
	end
end


local list = {}
for k, _ in pairs( vfxTable ) do
	list[#list + 1] = k
	local filePath = ( string.gsub( VFXRoot.."\\"..k, "\\", "/" ) )
	print( filePath )
end

print( "\n" )

table.sort( list )

local vfxPathList = {}
for _, v in ipairs( list ) do
	local fullPath = VFXRoot.."\\"..v
	fullPath = ( string.gsub( fullPath, "\\", "/" ) )..".prefab"
	vfxPathList[ fullPath ] = fullPath
end

local usedVFXList = {}
local unusedVFXList = {}
for dir in io.popen( string.format( "dir \"%s\" /s/b", SubVFXRoot ) ):lines() do
	local filePath = ( string.gsub( dir, "\\", "/" ) )
	if not endswith( filePath, ".meta" ) then
		if vfxPathList[ filePath ] then
			usedVFXList[ #usedVFXList + 1 ] = filePath
		else
			unusedVFXList[ #unusedVFXList + 1 ] = filePath
		end
	end
end

print( string.format( "list all used vfx at : %s\n", SubVFXRoot ) )
for _, v in ipairs( usedVFXList ) do
	print( v )
end
print( "\n" )

print( string.format( "list all unused vfx at : %s\n", SubVFXRoot ) )
for _, v in ipairs( unusedVFXList ) do
	print( v )
	local metaFile = v..".meta"
end
print( "\n" )
