--$cmd luaf scene/__main__.lua
local LuaThread = LuaThread
local NGUIForLua = NGUIForLua

Ares = nil
if not Ares then
	--package.loaded["Ares"] = nil
	local _Ares = require "Ares"
	Ares = _Ares
end

local yield = yield
local sleep = sleep
local exit = exit
local WorldState = nil

local function WaitForLocalPlayer()
	if not WorldState then
		exit( 2 )
	end
	local scene = nil
	local lp = nil
	while true do
		scene = WorldState.activeScene
		if scene then
			lp = scene:GetLocalPlayer()
			if lp then
				break
			end
		end
		yield()
	end
	return lp
end

local function WaitForScene()
	if not WorldState then
		exit( 2 )
	end
	local scene = nil
	while true do
		scene = WorldState.activeScene
		if scene then
			break
		end
		yield()
	end
	return scene
end

local function onExit()
	--print( "onExit: "..LuaThread.GetSourceFile() )
end

local showArrow = function()
	local UIManager = Common.UIManager
	local UnityUtils = Common.UnityUtils
	local SinglePanelMgr = SinglePanelMgr_mt.__static_instance.sharedInstance
	local UIManager = UIManager.__static_instance.sharedInstance
	local MissionManager = NewMission.MissionManager.__static_instance.Instance
	local buttonHandler = nil
	local arrow = nil
	if not arrow and SinglePanelMgr and UIManager then
		local MainTraceMissionPanel = SinglePanelMgr.MainTraceMissionPanel
		if MainTraceMissionPanel then
			local transform = MainTraceMissionPanel.transform
			local icon = transform:FindChild( "Anchor/Offset/TraceButton/MissTypeLogo" )
			local button = transform:FindChild( "Anchor/Offset/TraceButton" )
			if not icon or not button then
				--print( "MissionTracePanel: control not found!" )
				exit( 1 )
			end
			arrow = SinglePanelMgr:SetMissHintEffect( icon )
			if arrow then
				local MissionTraceButtonCallback = function( gameObject )
					if gameObject then
						--print( "Mission tracing button clicked: "..gameObject.name )
						if arrow then
							arrow:Close()
							arrow = nil
							if buttonHandler and button then
								if button.gameObject then
									--print( "remove lua button callback: MissionTraceButtonCallback" )
									NGUIForLua.UIEventListener_Remove_onClick( button.gameObject, buttonHandler )
								end
								buttonHandler = nil
							end
						end
					end
				end
				--print( "Register button handler in lua" )
				if not buttonHandler then
					--print( "add lua button callback: MissionTraceButtonCallback" )
					buttonHandler = NGUIForLua.UIEventListener_Add_onClick( button.gameObject, MissionTraceButtonCallback )
					atexit(
						function()
							if button then
								if buttonHandler then
									--print( "Unregister button handler in lua" )
									if button.gameObject then
										--print( "atexit remove lua button callback: MissionTraceButtonCallback" )
										NGUIForLua.UIEventListener_Remove_onClick( button.gameObject, buttonHandler )
									end
									buttonHandler = nil
								end
							end
							if arrow then
								arrow:Close()
								arrow = nil
							end
						end
					)
				end
			else
				--print( "new mission hint effect already exists, do nothing." )
			end
		end
	end
end

function chat_repaire()
	while true do
		local ui = Common.UIManager.sharedInstance
		if ui then
			local mainPanel = ui:FindScene( "MainPanel" )
			if mainPanel then
				local all = mainPanel.transform:FindChild( "Bottom/Chat/Window-G/Window-G/Chat-Panel/All" )
				if all then
					local rigidbody = all:GetComponent( "Rigidbody" )
					if rigidbody then
						rigidbody.isKinematic = true
						break
					end
				end
			end
		end
		yield()
	end
end

local function smain( scene )
	print( scene.name )
	print( "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx" )
	--ScriptManager.sharedInstance:RunFile( "patch/chat.lua" )
	chat_repaire()
	local localPlayer = scene:GetLocalPlayer()
	while true do
		--print( "check mission accepting event in lua when player level < 10" )
		localPlayer = WaitForLocalPlayer()
		local level = localPlayer:GetProp_Level()
		if level > 10 then
			--print( "Player Level greater than 5, skip NewMission hint..."..LuaThread.GetSourceFile() )
			break
		end
		sleep( 2000 )
	end
end

function main()
	atexit( onExit )
	--print( "lua main entered."..LuaThread.GetSourceFile() )
	WorldState = WorldState_mt.__static_instance
	local Sig = Game.Sig.__static_instance
	local missionSigs = Sig.mission
	-- register AddNewAcceptTask event callback
	if missionSigs then
		local func = missionSigs:AddEvent_AddNewAcceptTask(
			function( taskId )
				--print( "AddNewAcceptTask: "..tostring( taskId ) )
				showArrow()
			end
		)
		if func then
			atexit(
				function()
					--print( "atexit, remove event: AddNewAcceptTask" )
					missionSigs:RemoveEvent_AddNewAcceptTask( func )
					func = nil
				end
			)
		end
	end

	local scene = WaitForScene()
	smain( scene )
	--print( "lua main exit." )
end

