local Networker = require "Networker"
local DatabaseTool = require "DatabaseTool"
local yield = yield
local NGUIForLua = NGUIForLua

--------------------------------function------------------------------------------
local function testFunc( sceneName, gameObject )
	print("--------------------------------------- scene name:"..sceneName)
	if gameObject then
		print( gameObject.name )
	end
end

------------------------------register function---------------------------------
local hooks = {
	{
        panelName = "StartGamePanel",
        func = testFunc,
    },
}



-------------------------------------------------------------------------------
local _hooks = {}
local _luaFunc = {}
setmetatable( _luaFunc, {} )

for _, v in pairs( hooks ) do
	if v then
		_hooks[#_hooks + 1] = v.panelName
		_luaFunc[v.panelName] = v.func
	end
end

function OpenScene( sceneName, gameObject )
	if _luaFunc[sceneName] then
		_luaFunc[sceneName]( sceneName, gameObject )
	end
end


local function GetHookedInfo()
	return _hooks
end

return {
	OpenScene = OpenScene,
	GetHookedInfo = GetHookedInfo,
}

