
local SigDef = {
	namespaces = {
	},
	defines = {
	}
}

local function Namespace( n )
	local index = table.maxn( SigDef.namespaces )
	SigDef.namespaces[ index + 1 ] = n
end

local function AddEx( groupName, name, tolua, ... )
	local def = {}
	def.group = groupName
	def.name = name
	def.params = {}
	def.tolua = tolua
	local _arg = nil
	if table.pack then
		_arg = table.pack( ... ) -- lua 5.2
	else
		_arg = arg -- lua 5.1
	end
	if _arg then
		for i, v in ipairs( _arg ) do
			def.params[ #def.params + 1 ] = v
		end
	end
	SigDef.defines[ #SigDef.defines + 1 ] = def
end

local function Add( groupName, name, ... )
	AddEx( groupName, name, false, ... )
end

local function AddL( groupName, name, ... )
	AddEx( groupName, name, true, ... )
end

Namespace( "Goods" );
Namespace( "UniScene" );
Namespace( "GwScene" );
Namespace( "Network.Messages" );
Namespace( "UnityEngine" );

Add( "scene", "RequestEnterWorld" );
Add( "scene", "EnterScene", "int mapid" );
Add( "scene", "ExitScene", "int mapid" );

Add( "scene", "ExitGame" );
Add( "scene", "RequestChangeMap", "String name" );
Add( "scene", "UpdateItem", "ContainerType type", "int index" );
Add( "scene", "UpdateAllItems", "ContainerType type" );
Add( "scene", "AddItem", "ContainerType type", "int index" );
Add( "scene", "RemoveItem" );
Add( "scene", "RoleDead", "Character owner", "Character.DeadInfo deadMsg" );
Add( "scene", "Disapear", "UInt64 code" );
Add( "scene", "QuitToLogin" );
Add( "scene", "LeaveWorldState", "GwScene.Scene scene" );
Add( "scene", "HangUpModelChange" ,"Character owner");
Add( "scene", "ChangeMap", "Database.Mapsetting map" );
Add("scene","CopyMapResult","Database.Mapsetting map");
Add("scene", "OpenLoadingPanel");
Add( "scene", "ClosePanel", "String panelName" );

Add( "skill", "SkillCDUpdate", "Character owner", "int index" );
Add( "skill", "InitPassiveSkillSlotInfo", "UInt64 code" );
Add( "skill", "InitInitiativeSkillSlotInfo", "UInt64 code" );
Add( "skill", "InitTransformSkillSlotInfo", "UInt64 code" );
Add( "skill", "ChangeSInkillSlotInfo", "UInt64 code", "uint index", "uint mark", "uint oldIndex", "uint oldID", "uint skillID" );
Add( "skill", "ChangeSPakillSlotInfo", "UInt64 code", "uint index", "uint mark", "uint oldIndex", "uint oldID", "uint skillID" );
Add( "skill", "ChangeTransformSkillSlotInfo", "UInt64 code", "uint index", "uint mark", "uint oldIndex", "uint oldID", "uint skillID" );
Add( "skill", "SkillInfoList", "Character owner" );
Add( "skill", "SkillInfo", "UInt64 code", "uint skillID" );
Add( "skill", "SetCD", "UInt64 code", "int skillID" );
Add( "skill", "InitiativeHangUpSkillSlot" ,"Character owner");
Add( "skill", "AddHangUpSkillSlot", "byte skillSlotIndex" ,"Character owner");
Add( "skill", "DelHangUpSkillSlot", "byte skillSlotIndex" ,"Character owner");
Add( "skill", "SetSkillWaitCD", "uint skillId","Character owner" );
Add( "skill", "CancelSkillWaitCD", "uint skillId" ,"Character owner");
Add( "skill", "SkillSaveNumberChange", "uint skillId","Character owner" );

Add( "skill", "AddBuff", "Character owner", "UInt64 uid", "int icon", "float period", "bool isRotate" );
Add( "skill", "DeleteBuff", "Character owner", "UInt64 uid" );
Add( "skill", "UpdateBuff", "Character owner", "UInt64 uid", "int icon", "float period", "bool isRotate" );

Add( "skill", "BanSkillAll", "bool isBan" );
Add( "skill", "BanSkillMp", "bool isBan" );
Add( "skill", "BanSkillWeapon", "bool isBan" );
Add( "skill", "BanUseGoods", "bool isBan" );
Add( "skill", "NoSelect", "bool isSelect" );

Add( "skill", "ExchangeSkill", "bool toSubtitude" );
Add( "skill", "PreLoadSkill", "uint skillID" );


Add( "buff", "GetPKProtectBuff", "Character owner" );
Add( "buff", "EndPKProtectBuff", "Character owner" );

Add( "property", "AllBattlePropInit", "Character owner" );
Add( "property", "AttributeChange_int", "Character owner", "RolebaseAttribute type", "int value" ,"bool relativeValue");
Add( "property", "AttributeChange_str", "Character owner", "RolebaseAttribute type", "String value" );
Add( "property", "AttributeChange_dou", "Character owner", "RolebaseAttribute type", "double value" );
Add( "property", "AttributeChange_float", "Character owner", "RolebaseAttribute type", "float value" );
Add( "property", "AttributeChange_obj", "Character owner", "RolebaseAttribute type", "object value" );
Add( "property", "AttributeChange_UInt64", "Character owner", "RolebaseAttribute type", "UInt64 value" );
Add( "property", "BattleProp", "Character owner", "AllBattleProp type", "float value" );
Add( "property", "UpdateHateInfo", "Character owner", "UInt64 targetCode", "SByte opreate" );
Add( "property", "ClearHateInfo" );
Add( "property", "LevelUpTo", "int level" );

Add( "entity", "EntityModelChanged", "Entity entity" );
Add( "npc", "NPCTalk", "UInt64 code", "int id" );
Add( "monster", "MonsterEntityInited", "Monster monster" );
Add( "pet", "EnterMountState", "Pet pet" );
Add( "pet", "ExitMountState", "Pet pet" );
Add( "pet", "EnterSleepState", "Pet pet" );
Add( "pet", "ExitSleepState", "Pet pet" );
Add( "pet", "InitSystemPet", "Pet pet" );
Add( "pet", "PetCallBack", "Pet pet" );
Add( "pet", "PetEntityInited", "Pet pet" );
Add( "player", "PlayerEntityInited", "Player player" );
Add( "player", "PlayerTargetChanged", "UInt64 targetCode" );


Add( "player", "PlayerRevived", "Player player" );
Add( "player", "PlayerDead", "Player player" );
Add( "player", "PlayerRevived_NoEntity", "GS2U_BroadcastTeamRevive msg" );
Add( "player", "PlayerDead_NoEntity", "GS2U_DeadToTeam msg" );
Add( "player", "PlayerPrompt", "TMenuType type", "bool value" );
Add( "player", "TransformInfoChanged");
Add( "player", "TransformLevelChanged", "int from", "int to","bool isInit");


Add( "player", "LevelReward", "List<Byte> ary" );
Add( "player", "OnlineReward", "List<UInt32> ary" );
Add( "player", "RefindRes", "List<RefindResInfo> ary" );


Add( "CustomEvent", "PlayerDead_TalkingData", "string type", " string jsonData" );
Add( "CustomEvent", "Currency_Statistics", "string type", " string jsonData" );



AddL( "mission", "AddNewAcceptTask", "int missId" );
Add( "mission", "AddNewCompleteTask", "int missId" );
Add( "mission", "UpdateAcceptTask", "acceptedBaseTask acceptTaskInfo" );
Add( "mission", "EnterPlanesInstance" );
Add( "mission", "SyncTaskWithServer" );
Add( "mission", "MissionCompleted" );
Add( "mission", "NewTaskAccepted" );
Add( "mission", "ClearCornerMark", "int id" );

Add( "goods", "GoodsUpdateOne", "Byte bagType", "Byte index" );
Add( "goods", "GoodsUpdateAll", "Byte bagType" );
Add( "goods", "GoodsDelete", "UInt64 uid" );
Add( "goods", "AddBagSlot", "Byte bagType", "Byte openNum" );
Add( "goods", "BagPrompt", "Byte bagType", "bool needPrompt" );
Add( "goods", "ItemCD", "Byte bagType", "UInt16 itemType" );

Add( "trade", "QueryTradeList", "GS2U_QueryTrade msg" );
Add( "trade", "QueryTradeInfo", "GS2U_QueryTradeInfo msg" );
Add( "trade", "OpTradeResult", "GS2U_OpTradeResult msg" );

Add("diamond", "UpdateSlotOne", "int index");
Add("diamond", "MergeResult", "UInt64 uid");
Add("diamond", "MergeFail" );

Add( "Cmd", "Command", "string param" );

Add( "Copy", "ProcessChanged", "float percent" );
Add( "Copy", "HightestScoreChanged", "int id", "int score" );

Add( "Friend", "OnFriendOnline", "UInt64 friendID" );
Add( "Friend", "OnFriendOffline", "UInt64 friendID" );
Add( "Friend", "OnFriendInfoChanged", "UInt64 friendID" );
Add( "Friend", "AddFriend", "UInt64 friendID", "TFriendType type" );
Add( "Friend", "DelFriend", "UInt64 friendID", "TFriendType type" );

Add( "FingerEvent", "OnSlashSucc", "Vector2 fingerDir" );
Add( "FingerEvent", "OnSlashSuccExpert", "Vector2 startPos", "Vector2 endPos" );

Add( "Mount", "InfoChanged" );
Add( "Mount", "ModelChanged", "int modelID" );
Add( "Mount", "GetNewModel", "int modelID" );

Add( "NetCondition", "NetConditionChanged", "Network.SocketClient.Status condition" );
Add( "NetCondition", "CancelDisconnectedState" );
Add( "System", "MemoryWarning" );
Add( "System", "AppBecomeActiveFromBackground" );
Add( "UI", "PlaySound", "string sound" );

Add( "Map", "PlayerMoveToWayPointInfo", "System.UInt64 code", "List<Vector2> ptlist" );
Add( "Map", "GuildGrabMap", "List<ExpeditionMapInfo> ary" );
Add( "Chat", "WindowChanged", "int type" );

Add( "Player", "DeadResponse", "Player pl");
Add( "skill", "OpenSkillSlot", "SkillTypeMark type", "byte slotIndex","Character owner");
Add( "Setting", "RecvSettingInfo");
Add( "Setting", "RecvSettingInfoEX", "GameSettingData.GameSettingType type");

Add( "Download", "ProgressChanged", "float percent");

Add( "guild", "OnGuildDetailInfo", "GS2U_OpenGuildForm info");
Add( "guild", "OnGuildMemberInfo", "GS2U_RequestLookMemberList info");
Add( "guild", "OnModifyNotice", "string content");
Add( "guild", "UpdateApplyCount" );
Add( "guild", "OnQuitGuild" );
Add( "guild", "UpdateAttribute" );
Add( "guild", "OnShopList" );
Add( "guild", "OnShopListOne", "int index", "LookInfoItem info");
Add( "guild", "OnDonateCount", "GS2U_ReturnDonateTimes info");

Add( "MountAndPet", "OnUpdateOne", "MountAndPet.MAPNode info");
Add( "MountAndPet", "ChangePet", "MountAndPet.MAPNode to");
Add( "MountAndPet", "OnUpdateSkill", "UInt16 petID", "UInt16 skillID", "bool isAdd");
Add( "MountAndPet", "RecvPetSkillCast", "GS2U_PetSkillCastResult data");
Add( "MountAndPet", "RecvPetSkillReplace", "PetSkillReplace data");
Add( "MountAndPet", "UpdateBattlePetProp", "MountAndPet.MAPNode info");
Add( "MountAndPet", "OnForceChanged", "int petid", "int force");
Add( "MountAndPet", "PetStrAck", "int index");
Add( "MountAndPet", "PetStateChanged", "int id");
Add( "MountAndPet", "PetReborn", "MountAndPet.MAPNode info");
Add( "MountAndPet", "SynCatalog", "List<MountAndPet.CatalogInfo> ary");
Add( "MountAndPet", "SynRewardLevel", "Byte level");
Add( "MountAndPet", "SynStandSort", "List<UInt16> ary");
Add( "MountAndPet", "SynPower", "int power");
Add( "MountAndPet", "NoticeBuyPower", "GS2U_BuyPowerInfo info");
Add( "MountAndPet", "NoticeUpProps", "MountAndPet.MAPNode info");
Add( "MountAndPet", "NoticeSaveUpProps", "MountAndPet.MAPNode info");
Add( "MountAndPet", "NoticeSackNum", "int num");
Add( "MountAndPet", "NoticeBattleReport", "List<PvpBattleReportInfo> ary");
Add( "MountAndPet", "NoticeCityList", "List<MountAndPet.CityInfo> ary");
Add( "MountAndPet", "NoticeCityOne", "MountAndPet.CityInfo info");
Add( "MountAndPet", "NoticePosition");
Add( "MountAndPet", "PetSpirite");


Add( "Rank", "OnRecvRankInfo", "byte type" );
Add( "Rank", "OnRecvRankProp", "UInt64 playerID" );

Add( "Time", "TimeInterval", "int counterHashCode", "ulong time" );

Add( "fashion", "UpdateFashion", "Fashion.FashionData data");
Add( "fashion", "ChangeFashion", "Character owner", "RolebaseAttribute type", "int value");

Add( "GameAnalysis", "DiamondChanged", "Character owner", "RolebaseAttribute type", "int value", "UInt16 reason");
Add( "GameData", "LPersistentData_Cleared" );

Add( "Team", "TeamMemberChanged", "TeamManager.TeamInfo data", "UInt64 id");
Add( "Team", "TeamMemberPosChanged", "TeamManager.TeamInfo data");
Add( "Team", "PrepareEnterCopy", "int time");
Add( "Team", "SampleTeamApplySuccess");


Add( "QA", "OnRecvQuestion");
Add( "QA", "OnRecvLastResult");
Add( "QA", "OnRecvAnswerResult", "GS2U_PlayerAnswerResult msg");
Add( "QA", "OnRecvAnswerInfo", "GS2U_PlayerAnswerInfo msg");

Add( "PetRoundBattle", "PetBattleSequence", "List<RoundBattleSequence> petDataList");
Add( "PetRoundBattle",  "BeAttackPets","List<UInt64> beAttackCodeList");
Add( "PetRoundBattle", "PetMove", "UInt64 ownerCode");
Add( "PetRoundBattle", "PetUseSkill", "UInt64 ownerCode","int skillId");
Add( "PetRoundBattle", "PetBattleTurn","int nowTurn");
Add( "PetRoundBattle", "PetBeAttack", "List<RoundBattleResultHp> petResultList");
Add( "PetRoundBattle", "PetBattleOver");
Add( "PetRoundBattle", "PetBattleSceneQuit");

Add( "OperatorActivity", "OnRecvActivity","int type");
Add( "OperatorActivity", "OnRecvGetRewardAck","int type","int id");
Add( "OperatorActivity", "OnActStateChanged","int type","bool isOpen");

Add( "InputPriority", "InputPriorityChange","int preType","int nowType");

Add( "Net", "HeartBeatSent");
Add( "Net", "HeartBeatReceived");

Add( "Shop", "OnGetMallData","List<MallInfo> infos");

return SigDef
